// NAME: Charles Everett Edwall III (or just Chuck!)
// STUDENT ID: 23265927

/*
Here's a note on how this program works: It's a little different from the code you put up
on the Lab's web page.

Run the program by compiling the file Lab2.java and then running Lab2.class. DO NOT
run SavingsCalculator.class, one of the classes generated by javac. It has no main method;
it is merely a tool used by the main method in class Lab2.

I did also include a finished .JAR file, which you can run via "java -jar Lab2.jar".

Nitty Gritty:
Difference #1:                        The method calculateMonthlyPayment(int, int, double)
returns an array of size 2. The first element in the array, naturally, is the required
monthly payment to match or exceed the target savings as specified by the user. The second
element in the array is a type of "comment code" that I implemented, and can have a value
of 1, 2, or 3. I declared in class SavingsCalculator static integers TOO_MUCH_MONEY=1,
TAD_MUCH_MONEY=2, and JUST_RIGHT_AMOUNT=3, and leave it to the user of the method to
test for the comments, as is shown in Lab2.main. The comments are ultimately unnecessary
to the function of the program, but nonetheless allow SavingsCalculator.calculateMontlyPayment
to send another piece of information along with the required monthly payment. Adding fields
to this array and using them could allow the method to provide even more information about
its calculation, such as, for example, how much more money will be saved than the target over
the given timespan.

Difference #2:                        I implemented your SavingsCalculatorTester on my
own, adding in handling of the "comment" feature described above, as well as generally adding
in more descriptive output to the user, etc. All the required information, plus the "comments"
returned by the payment calculator, will be there. The function performed by your
"SavingsCalculatorTester.test" is present in my "Lab2.main". Running the compiled file
"Lab2.class" in the context of the other necessary files will produce the desired results.

Difference #3: //Good!                   This one is rather significant: I implemented the
calculateMonthlyPayment method in a static context. I didn't see why a certain run of the
method should be tied to any specific instance of the SavingsCalculator class. This way,
calculateMonthlyPayment is simply a utility that can be used anywhere the SavingsCalculator
class is available, whether or not an object of type SavingsCalculator is currently
accessible.

Difference #4:                        I added a couple of constructors to your Input class,
thinking I might use one. You never know when it might come in handy to create an Input object
and assign values to it all on one line. Not that it matters all that much anyway. :)

Difference #5:                        There is definitely a difference number 5, but it's
probably not significant enough to mention here. Probably a number 6 and 7, etc. But they're
not significant enough either. Reading this and the lab will get you a really good idea of
how this program works.

Note: Throughout the SavingsCalculator class are commented-out lines of code that print out
internal values. They're labeled with comments declaring them as such. If you de-comment
them, the program's run output will show all the internal values every time the loops run, and
they make the binary search algorithm and iterative loop in SavingsCalculator.amountSaved very,
very clear and easy to see.
*/
import java.util.*;
import java.lang.*;
import java.io.*;

public class Lab2 {
    private static Scanner read;

    public static void main ( String args[] ) {
        try {
            read = new Scanner( new FileReader("input.in" ));
        }
        catch( FileNotFoundException e ) {
            System.out.println( "Input file not found!" );
            System.exit( 1 );
        }

        Input values = new Input();

        boolean hasMore = getInput( values );
        int count = 1;
        System.out.println( "\nRun 1:" );
        int[] monthlyPayment = new int[2];
        while( hasMore ) {
            count++;
            monthlyPayment = SavingsCalculator.calculateMonthlyPayment( values.targetSavings, values.numberOfMonths, values.interestRate );
            System.out.println( "At target savings of $" + values.targetSavings + ", savings time of " + values.numberOfMonths + " months, and yearly interest rate of " + values.interestRate + "%,\n$" + (double)monthlyPayment[0]/100 + " is required per month." );
            if ( monthlyPayment[1] == SavingsCalculator.TOO_MUCH_MONEY ) {
                System.out.println( "     Quick Note: Even at one cent per month, you're going to end up with\n                 more than what you said you wanted to save. You're going\n                 to have to get creative or impatient!" );
            }
            if ( monthlyPayment[1] == SavingsCalculator.TAD_MUCH_MONEY ) {
                System.out.println( "     Quick Note: At the current number of cents you're paying, you'll end\n                 up with more than you said you wanted to save, but paying\n                 any less will be insufficient." );
            }
            if ( monthlyPayment[1] == SavingsCalculator.JUST_RIGHT_AMOUNT ) {
                System.out.println( "     Quick Note: Hey, somehow you managed to come up with values that yield\n                 EXACTLY your target savings - even when you ignore fractions\n                 of cents in monthly payments!" );
            }
            System.out.println("-----------------------------------------------------------------------------------");
            System.out.println("-----------------------------------------------------------------------------------");
            if( hasMore=getInput(values) )
                System.out.println( "\nRun " + (count) + ":" );
        }

    }

    /*
    This method stores (into whatever Input object it's passed) three VALID values for use with
    SavingsCalculator.calculateMonthlyPayment(int, int, double). Returns true for a successful run,
    false to report that there either was no new line in "input.in" or that there was bad data in
    the line it tried to read.
    */
    public static Boolean getInput(Input input)
    {
        if( read.hasNext() ) {
            try {
                if ( !read.hasNext() ) {
                    System.out.println( "\n---------------------------------------------------------------\nThe last line of data in the file you gave me is incomplete.\nI'm totally done with this junk. I hate this. I'm quitting NOW!\n---------------------------------------------------------------" );
                    return false;
                }
                input.targetSavings = read.nextInt();    //reading the first int in the line
            }
            catch( InputMismatchException e ) {
                System.out.print( "\n---------------------------------------------------------------\nHey! You tried to give me something that wasn't an integer\nfor the target savings! Bad user! " );        //insult the user
                try {
                    input.targetSavings = (int)read.nextDouble();        //if it doesn't work, try reading in a double
                    System.out.println( "Good news, though. I tried\nto read a double in, and will use the integer " + input.targetSavings + ".\n---------------------------------------------------------------" );
                }
                catch( InputMismatchException f ) {        //if there's not even a double, doubly insult the user!... then return false, to show whoever's calling this method the fact that there's bad data in here.
                    System.out.println( "Not only are you a bad\nuser, you're a user with no common sense. Didn't even give\nme a number.\n-----------------------------------------------------------------" );
                    return false;
                }
            }
            try {
                if ( !read.hasNext() ) {
                    System.out.println( "\n---------------------------------------------------------------\nThe last line of data in the file you gave me is incomplete.\nI'm totally done with this junk. I hate this. I'm quitting NOW!\n---------------------------------------------------------------" );
                    return false;
                }
                input.numberOfMonths = read.nextInt();        //reading the second int in the line
            }
            catch( InputMismatchException e ) {
                System.out.print( "\n---------------------------------------------------------------\nHey! You tried to give me something that wasn't an integer\nfor the number of months! Bad user! " );    //insult the user
                try {
                    input.numberOfMonths = (int)read.nextDouble();    //if it doesn't work, try reading in a double
                    System.out.println( "Good news, though. I tried\nto read a double in, and will use the integer " + input.numberOfMonths + ".\n---------------------------------------------------------------");
                }
                catch( InputMismatchException f ) {    //if there's not even a double, doubly insult the user!... then return false, to show whoever's calling this method the fact that there's bad data in here.
                    System.out.println( "Not only are you a bad\nuser, you're a user with no common sense. Didn't even give\nme a number.\n---------------------------------------------------------------" );
                    return false;
                }
            }
            try {
                if ( !read.hasNext() ) {
                    System.out.println( "\n---------------------------------------------------------------\nThe last line of data in the file you gave me is incomplete.\nI'm totally done with this junk. I hate this. I'm quitting NOW!\n---------------------------------------------------------------" );
                    return false;
                }
                input.interestRate = read.nextDouble();    //reading the third number (first double) in the line
            }
            catch( InputMismatchException e ) {
                System.out.print( "\n---------------------------------------------------------------\nHey! You tried to give me something that wasn't a double\nfor the interest rate! Bad user! " );
                try {
                    input.interestRate = (double)read.nextInt();    //if it doesn't work, try reading an int
                    System.out.println( "Good news, though. I tried\nto read an integer in, and will use the double " + input.interestRate + ".\n---------------------------------------------------------------" );
                }
                catch(InputMismatchException f){    //if there's not even an int, then INSULT that user!
                    System.out.println( "Not only are you a bad\nuser, you're a user with no common sense. Didn't even give\nme a number.\n---------------------------------------------------------------" );
                    return false;
                }
            }

            boolean valid = true;
            if( 0 > input.targetSavings ) {
                System.out.println( "Please enter a POSITIVE number, preferably an integer, for the target savings" );    //be generally annoying and irritable when errors are encountered.
                valid = false;
            }
            if( 1 > input.numberOfMonths ) {
                System.out.println( "Timespan has to include at least a month..." );    //add a hint of sarcasm by stating the obvious so seriously
                valid = false;
            }
            if( input.interestRate < 0 ) {
                System.out.println( "Who would EVER invest in something with a negative interest rate?! Apparently YOU would. :-)" );    //insult the user from behind a thinly veiled mask of a smile
                valid = false;
            }
            if( valid )    //by the time this "if" statement is satisfied, it's certain that this Input object will contain three values that are VALID for the SavingsCalculator.calculateMonthlyPayment method.
                return true;
            else return false;    //if any one of the above three errors occurred, then it's not valid data for the SavingsCalc. I return false!
        }
        return false;    //if there really wasn't a line there in the first place, the code skips to here and returns false, meaning "There was no next line."
    }
}





















class SavingsCalculator {
    private static double interestRate;
    private static int numberOfMonths;
    public static int TOO_MUCH_MONEY = 1;
    public static int TAD_MUCH_MONEY = 2;
    public static int JUST_RIGHT_AMOUNT = 3;

    /*
    This returns an array of size 2 containing the required monthly payment as the first element and a "comment"
    integer of 1, 2, or 3 as the second element. The comment value is ultimately unnecessary, but provides some
    extra information as to the calculation. "Required monthly payment" refers to the minimum amount of cents
    necessary to be deposited each month in order to attain a minimum of "targetSavings" dollars by the end of
    a timespan of "months" months at an interest rate of "rate".
    */
    public static int[] calculateMonthlyPayment(int targetSavings, int months, double rate) {
        numberOfMonths = months;
        interestRate = rate;
        targetSavings *= 100;
        int[] returnArray = new int[2];
        returnArray[1] = 0;
        boolean earlyExit = false;
        if ( targetSavings == 0 ) {
            returnArray[0] = 0;    //Before I implemented the commenting feature described at the top of this file, this used to say "return 0;" As you can see, I had to work around the fact that I couldn't just return 0 and exit the method; I had to implement the comment.
            earlyExit=true;
        }
        int min = 0;
        int max = (int)( (targetSavings/numberOfMonths) * 1.3+2 );
        int med = (min + max) / 2;
        int candidatePayment = -4;
        int currentSavings = -5;
        if ( !earlyExit ) {
            while( (min < med) && (med < max) ) {    //Here's the binary search that you asked for.
                //System.out.println("Trying amountSaved(med) with min="+min+", med="+med+", and max="+max+".");            //Output that I used to make sure it worked. Feel free to un-comment and recompile if you wish.
                currentSavings = amountSaved( med );
                candidatePayment = med;
                if ( currentSavings > targetSavings ) {
                    max = med;
                }
                if ( currentSavings < targetSavings ) {
                    min=med;
                }
                if ( currentSavings == targetSavings ) {
                    earlyExit = true;
                    returnArray[0] = candidatePayment;
                    min = max;
                }
                med = (min + max) / 2;
            }
        }
        //with a normal, uneventful run of the binary search, this puts candidatePayment into the first field of the array to be returned.
        if ( !earlyExit )
            returnArray[0] = candidatePayment;
        //in some cases, the program will exit with candidatePayment less by one than what is required. This fixes that.
        if ( currentSavings < targetSavings ) {
            currentSavings = amountSaved( candidatePayment + 1 );
            returnArray[0] = candidatePayment + 1;
        }
        // Putting a return "comment" (See top of file or the README file) in the second field of the array
        if ( currentSavings == targetSavings )
            returnArray[1] = JUST_RIGHT_AMOUNT;
        if ( currentSavings > targetSavings && candidatePayment == 1 )
            returnArray[1] = TOO_MUCH_MONEY;
        if ( currentSavings > targetSavings && candidatePayment > 1 )
            returnArray[1] = TAD_MUCH_MONEY;

        return returnArray;
    }

    /*
    returns the amount saved after the timespan, given a monthly deposit of CANDIDATE cents.
    NOTE: THIS CURRENTLY WORKS BY FIRST COMPOUNDING INTEREST, THEN ADDING MONTHLY PAYMENT.
    IF THESE TASKS ARE SWITCHED, LESS MONTHLY PAYMENT WILL BE REQUIRED. That's why there are
    two separate println calls commented out within the for loop. Originally, I had this method
    first compound, then add, but I changed it to "first add, then compound."
    */
    private static int amountSaved( int candidate ) {
        int total = 0;
        for ( int i=0; i<numberOfMonths; i++ ) {
            int temp = total;    //unnecessary; used in the debugging outputs
            total = (int)( (double)total * (1.0 + interestRate / (12 * 100.0) ) );
            int temp2 = total;    //unnecessary; used in the debugging outputs
            total += candidate;
            //System.out.println("       amountSaved is adding " + candidate + " to " + temp + ", then multiplying its running total by " + (1.0+interestRate/100.0) + " and rounding down, obtaining a new current total of "+total+".");    //This is for adding payment first, then compounding: Output that I used to make sure it worked. Feel free to un-comment and recompile if you wish. Just make sure that this is the right output for what's happening.
            //System.out.println("       amountSaved is multiplying its running total, "+temp+", by " + (1.0+interestRate/100.0) + ", to obtain " + temp2 + ", then adding the next payment, which is " +candidate+ ". After rounding down, it obtains a new current total of "+total+".");    //This is for compounding first, then adding payment: Output that I used to make sure it worked. Feel free to un-comment and recompile if you wish. Just make sure that this is the right output for what's happening.
        }
        //System.out.println("     amountSaved returned " + total + " from candidate payment of " + candidate + ".");    //Output that I used to make sure it worked. Feel free to un-comment and recompile if you wish.
        return total;
    }
}

class Input {
    public int targetSavings = -1;
    public int numberOfMonths = -1;            //I added a couple of constructors to your Input class, thinking I might use the second one.
    public double interestRate = -1;
    public Input() {}
    public Input( int t, int n, double r ) {
        targetSavings = t;
        numberOfMonths = n;
        interestRate = r;
    }
}
